diff --git a/design/admin2/stylesheets/pagelayout.css b/design/admin2/stylesheets/pagelayout.css
index 201c51c..600c84b 100644
--- a/design/admin2/stylesheets/pagelayout.css
+++ b/design/admin2/stylesheets/pagelayout.css
@@ -475,6 +475,33 @@ div#contentstructure ul#content_tree_menu div.loaded
     display: block;
 }
 
+div#contentstructure ul#content_tree_menu div.error
+{
+    white-space: normal;
+    color: grey;
+    margin: 2px;
+    padding: 4px;
+    border: 1px solid #ddd;
+    -moz-border-radius: 5px;
+    -webkit-border-radius: 5px;
+    border-radius: 5px;
+}
+
+div#contentstructure ul#content_tree_menu div.error > span
+{
+    display: inline-block;
+    height: 9px;
+    width: 9px;
+    -moz-border-radius: 9px;
+    -webkit-border-radius: 9px;
+    border-radius: 9px;
+    margin-right: 4px;
+    background: Red;
+    background: -webkit-gradient(linear, left top, left bottom, from(#FF9999), to(Red));
+    background: -moz-linear-gradient(top,  OrangeRed,  Red);
+    background: linear-gradient(top, OrangeRed, Red);
+}
+
 div#contentstructure ul#content_tree_menu div.hidden
 {
     display: none;
diff --git a/design/admin2/templates/contentstructuremenu/content_structure_menu_dynamic.tpl b/design/admin2/templates/contentstructuremenu/content_structure_menu_dynamic.tpl
index c340bab..353419a 100644
--- a/design/admin2/templates/contentstructuremenu/content_structure_menu_dynamic.tpl
+++ b/design/admin2/templates/contentstructuremenu/content_structure_menu_dynamic.tpl
@@ -108,7 +108,7 @@ function ContentStructureMenu( path, persistent )
     this.updateCookie = function()
     {
         if ( !this.useCookie )
-            return; 
+            return;
         this.cookie = this.open.join('/');
         expireDate  = new Date();
         expireDate.setTime( expireDate.getTime() + this.cookieValidity * 86400000 );
@@ -388,7 +388,7 @@ function ContentStructureMenu( path, persistent )
             'url': url,
             'dataType': 'json',
             'success': function( data, textStatus )
-            {             
+            {
                 var html = '<ul>', items = [];
                 // Filter out nodes to hide
                 for ( var i = 0, l = data.children_count; i < l; i++ )
@@ -419,38 +419,34 @@ function ContentStructureMenu( path, persistent )
             },
             'error': function( xhr, textStatus, errorThrown )
             {
-                if ( aElement )
+                divElement.className = 'error';
+                if (aElement) aElement.className = 'openclose-error';
+
+                function setErrorText( txt )
                 {
-                    aElement.className = 'openclose-error';
+                    if (aElement) aElement.title = txt;
+                    else divElement.innerHTML = '<span></span>' + txt;
+                }
 
-                    switch( xhr.status )
+                switch( xhr.status )
+                {
+                    case 403:
                     {
-                        case 403:
-                        {
-{/literal}
-                            aElement.title = '{"Dynamic tree not allowed for this siteaccess"|i18n('design/admin/contentstructuremenu')|wash(javascript)}';
-{literal}
-                        } break;
-
-                        case 404:
-                        {
-{/literal}
-                            aElement.title = '{"Node does not exist"|i18n('design/admin/contentstructuremenu')|wash(javascript)}';
-{literal}
-                        } break;
-
-                        case 500:
-                        {
-{/literal}
-                            aElement.title = '{"Internal error"|i18n('design/admin/contentstructuremenu')|wash(javascript)}';
-{literal}
-                        } break;
-                    }
-                    aElement.onclick = function()
+{/literal}              setErrorText( '{"Dynamic tree menu is disabled for this siteaccess!"|i18n("design/admin/contentstructuremenu")|wash("javascript")}' );{literal}
+                    } break;
+                    case 404:
                     {
-                        return false;
+{/literal}              setErrorText( '{"Node does not exist"|i18n("design/admin/contentstructuremenu")|wash("javascript")}' );{literal}
+                    } break;
+                    default:
+                    {
+{/literal}              setErrorText( '{"Internal error"|i18n("design/admin/contentstructuremenu")|wash("javascript")}' );{literal}
                     }
                 }
+                if (aElement) aElement.onclick = function()
+                {
+                    return false;
+                };
             }
         });
 
diff --git a/design/admin2/templates/page_head_style_inline.tpl b/design/admin2/templates/page_head_style_inline.tpl
index 35f5de9..f837f3b 100644
--- a/design/admin2/templates/page_head_style_inline.tpl
+++ b/design/admin2/templates/page_head_style_inline.tpl
@@ -1,15 +1,4 @@
 {* DO NOT EDIT THIS FILE! Use an override template instead. *}
-{def $dynamic_csm_disabled = ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|ne('enabled')}
-
-{if $dynamic_csm_disabled}
-<style type="text/css">
-
-div#contentstructure ul#content_tree_menu ul li {ldelim} padding-left: 0; {rdelim}
-div#contentstructure ul#content_tree_menu ul ul {ldelim} margin-left: 20px; {rdelim}
-
-</style>
-{/if}
-
 {literal}
 <!--[if lt IE 8]>
 <style>
diff --git a/design/admin2/templates/parts/content/menu.tpl b/design/admin2/templates/parts/content/menu.tpl
index 49daa02..eb8e9f6 100644
--- a/design/admin2/templates/parts/content/menu.tpl
+++ b/design/admin2/templates/parts/content/menu.tpl
@@ -7,11 +7,7 @@
 
 {* Treemenu. *}
 <div id="contentstructure">
-{if ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|eq('enabled')}
     {include uri='design:contentstructuremenu/content_structure_menu_dynamic.tpl'}
-{else}
-    {include uri='design:contentstructuremenu/content_structure_menu.tpl'}
-{/if}
 </div>
 
 {* Trashcan. *}
diff --git a/design/admin2/templates/parts/media/menu.tpl b/design/admin2/templates/parts/media/menu.tpl
index fb48658..4fb17ab 100644
--- a/design/admin2/templates/parts/media/menu.tpl
+++ b/design/admin2/templates/parts/media/menu.tpl
@@ -8,11 +8,7 @@
 
 {* Treemenu. *}
 <div id="contentstructure">
-{if ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|eq('enabled')}
     {include uri='design:contentstructuremenu/content_structure_menu_dynamic.tpl' custom_root_node_id=ezini( 'NodeSettings', 'MediaRootNode', 'content.ini')}
-{else}
-    {include uri='design:contentstructuremenu/content_structure_menu.tpl' custom_root_node_id=ezini( 'NodeSettings', 'MediaRootNode', 'content.ini')}
-{/if}
 </div>
 
 {* Trashcan. *}
diff --git a/design/admin2/templates/parts/my/menu.tpl b/design/admin2/templates/parts/my/menu.tpl
index 8190aa4..69c1f89 100644
--- a/design/admin2/templates/parts/my/menu.tpl
+++ b/design/admin2/templates/parts/my/menu.tpl
@@ -25,11 +25,7 @@
 
 {* Treemenu. *}
 <div id="contentstructure">
-{if ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|eq('enabled')}
     {include uri='design:contentstructuremenu/content_structure_menu_dynamic.tpl' custom_root_node=$custom_root_node menu_persistence=false() hide_node_list=array(ezini( 'NodeSettings', 'DesignRootNode', 'content.ini'), ezini( 'NodeSettings', 'SetupRootNode', 'content.ini'))}
-{else}
-    {include uri='design:contentstructuremenu/content_structure_menu.tpl' custom_root_node_id=1}
-{/if}
 </div>
 
 {* DESIGN: Content END *}</div></div></div>
diff --git a/design/admin2/templates/parts/user/menu.tpl b/design/admin2/templates/parts/user/menu.tpl
index 72dc573..d9f74f9 100644
--- a/design/admin2/templates/parts/user/menu.tpl
+++ b/design/admin2/templates/parts/user/menu.tpl
@@ -31,11 +31,7 @@
 
 {* Treemenu. *}
 <div id="contentstructure">
-{if ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|eq('enabled')}
     {include uri='design:contentstructuremenu/content_structure_menu_dynamic.tpl' custom_root_node_id=ezini( 'NodeSettings', 'UserRootNode', 'content.ini')}
-{else}
-    {include uri='design:contentstructuremenu/content_structure_menu.tpl' custom_root_node_id=ezini( 'NodeSettings', 'UserRootNode', 'content.ini')}
-{/if}
 </div>
 
 {* trashcan. *}
diff --git a/design/admin2/templates/popupmenu/popup_context_menu.tpl b/design/admin2/templates/popupmenu/popup_context_menu.tpl
index 8885a9d..b1d6d6d 100644
--- a/design/admin2/templates/popupmenu/popup_context_menu.tpl
+++ b/design/admin2/templates/popupmenu/popup_context_menu.tpl
@@ -29,16 +29,6 @@ menuArray['ContextMenu']['elements']['menu-create-here']= {ldelim} 'disabled_cla
     <a id="menu-remove" href="#" onmouseover="ezpopmenu_mouseOver( 'ContextMenu' )" onclick="ezpopmenu_submitForm( 'menu-form-remove' ); return false;">{"Remove"|i18n("design/admin/popupmenu")}</a>
     <a id="menu-advanced" class="more" href="#" onmouseover="ezpopmenu_showSubLevel( event, 'Advanced', 'menu-advanced' ); return false;">{'Advanced'|i18n( 'design/admin/popupmenu' )}</a>
     <hr />
-{if ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|ne('enabled')}
-    <a id="menu-expand" href="#" onmouseover="ezpopmenu_mouseOver( 'ContextMenu' )"
-       onclick="ezcst_expandSubtree( CurrentSubstituteValues['%nodeID%'] ); ezpopmenu_hideAll(); return false;">{"Expand"|i18n("design/admin/popupmenu")}</a>
-    <a id="menu-collapse" href="#" onmouseover="ezpopmenu_mouseOver( 'ContextMenu' )"
-       onclick="ezcst_collapseSubtree( CurrentSubstituteValues['%nodeID%'] ); ezpopmenu_hideAll(); return false;">{"Collapse"|i18n("design/admin/popupmenu")}</a>
-{else}
-    <a id="menu-collapse" href="#" onmouseover="ezpopmenu_mouseOver( 'ContextMenu' )"
-       onclick="treeMenu.collapse( CurrentSubstituteValues['%nodeID%'] ); ezpopmenu_hideAll(); return false;">{"Collapse"|i18n("design/admin/popupmenu")}</a>
-{/if}
-    <hr />
     <a id="menu-bookmark" href="#" onmouseover="ezpopmenu_mouseOver( 'ContextMenu' )"
        onclick="ezpopmenu_submitForm( 'menu-form-addbookmark' ); return false;">{"Add to my bookmarks"|i18n("design/admin/popupmenu")}</a>
     <a id="menu-notify" href="#" onmouseover="ezpopmenu_mouseOver( 'ContextMenu' )"