diff --git a/kernel/classes/ezsiteaccess.php b/kernel/classes/ezsiteaccess.php
index 49215b0..e980ab6 100644
--- a/kernel/classes/ezsiteaccess.php
+++ b/kernel/classes/ezsiteaccess.php
@@ -29,6 +29,7 @@ class eZSiteAccess
     const TYPE_SERVER_VAR = 7;
     const TYPE_URL = 8;
     const TYPE_HTTP_HOST_URI = 9;
+    const TYPE_HTTP_HOST_URI_DEFAULT = 10;
 
     const SUBTYPE_PRE = 1;
     const SUBTYPE_POST = 2;
@@ -307,14 +308,16 @@ class eZSiteAccess
                 case 'host_uri':
                 {
                     $type = eZSiteAccess::TYPE_HTTP_HOST_URI;
-                    if ( $ini->hasVariable( 'SiteAccessSettings', 'HostUriMatchMapItems' ) )
-                    {
-                        $match_item = $uri->element( 0 );
-                        if ( $match_item )
-                        {
+                    $match_item = $uri->element( 0 );
+
                             $matchMapItems = $ini->variableArray( 'SiteAccessSettings', 'HostUriMatchMapItems' );
                             $defaultHostMatchMethod = $ini->variable( 'SiteAccessSettings', 'HostUriMatchMethodDefault' );
 
+                            $useFirstHostMatchUseAsDefaultAccess = $ini->variable( 'SiteAccessSettings', 'HostUriMatchUseFirstHostMatchAsDefaultAccess' );
+                            $findDefaultAccess = $useFirstHostMatchUseAsDefaultAccess ? $useFirstHostMatchUseAsDefaultAccess === 'enabled' : false;
+
+                            $defaultAccess = false;
+
                             foreach ( $matchMapItems as $matchMapItem )
                             {
                                 $matchHost       = $matchMapItem[0];
@@ -322,9 +325,6 @@ class eZSiteAccess
                                 $matchAccess     = $matchMapItem[2];
                                 $matchHostMethod = isset( $matchMapItem[3] ) ? $matchMapItem[3] : $defaultHostMatchMethod;
 
-                                if ( $matchURI !== '' && $matchURI !== $match_item )
-                                    continue;
-
                                 switch( $matchHostMethod )
                                 {
                                     case 'strict':
@@ -352,6 +352,18 @@ class eZSiteAccess
 
                                 if ( $hasHostMatch )
                                 {
+                                    // remember firs element as default access if enabled
+                                    if ( $findDefaultAccess === true && $defaultAccess === false )
+                                    {
+                                        $defaultAccess = array( 'name' => $matchAccess,
+                                                                'type' => eZSiteAccess::TYPE_HTTP_HOST_URI_DEFAULT,
+                                                                'uri_part' => array( $matchURI ) );
+                                    }
+
+                                    // continue if uri not equal
+                                    if ( $matchURI !== '' && $matchURI !== $match_item )
+                                    continue;
+
                                     if ( $matchURI !== '' )
                                     {
                                         $uri->increase( 1 );
@@ -363,8 +375,13 @@ class eZSiteAccess
                                     return $access;
                                 }
                             }
-                        }
-                    }
+
+                            // if a default access was set use it
+                            if( $defaultAccess !== false )
+                            {
+                                return $defaultAccess;
+                            }
+
                 } break;
                 case 'index':
                 {
diff --git a/settings/site.ini b/settings/site.ini
index 56da928..e825932 100644
--- a/settings/site.ini
+++ b/settings/site.ini
@@ -676,6 +676,12 @@ HostMatchMapItems[]=eznoadmin.bf.ez.no;eznoadmin##!
 # Change HostUriMatchMethodDefault to one of these options to chenge default value
 HostUriMatchMethodDefault=strict
 
+# If no uri is matched from HostUriMatchMapItems with this setting you use the
+# first HostUriMatchMapItems where the Host is matched as defaultAccess
+# so a all rendered urls has then the uri param of the defaultAccess
+# enabled|disabled  default is disabled
+HostUriMatchUseFirstHostMatchAsDefaultAccess=disabled
+
 HostUriMatchMapItems[]
 ## This example will match on example.com/nor
 #HostUriMatchMapItems[]=example.com;nor;examle_nor