Index: bin/php/ezconvertdbcharset.php
===================================================================
--- bin/php/ezconvertdbcharset.php	(revision 23223)
+++ bin/php/ezconvertdbcharset.php	(working copy)
@@ -227,10 +227,10 @@
 
     $xmlAttributesInfo = array();
 
-    $xmlAttributesOption = split( ',', $xmlAttributesOption );
+    $xmlAttributesOption = explode( ',', $xmlAttributesOption );
     foreach ( $xmlAttributesOption as $attributeTableInfoOption )
     {
-        $attributeTableInfo = split( '\.', $attributeTableInfoOption );
+        $attributeTableInfo = explode( '.', $attributeTableInfoOption );
         switch ( count( $attributeTableInfo ) )
         {
             case 1:
@@ -270,10 +270,10 @@
 
     $xmlCustomDataInfo = array();
 
-    $xmlCustomDataOption = split( ',', $xmlCustomDataOption );
+    $xmlCustomDataOption = explode( ',', $xmlCustomDataOption );
     foreach ( $xmlCustomDataOption as $tableInfoOption )
     {
-        $tableInfo = split( '\.', $tableInfoOption );
+        $tableInfo = explode( '.', $tableInfoOption );
         switch ( count( $tableInfo ) )
         {
             case 2:
@@ -308,17 +308,17 @@
 
     $serializedDataInfo = array();
 
-    $serializedCustomDataOption = split( ',', $serializedCustomDataOption );
+    $serializedCustomDataOption = explode( ',', $serializedCustomDataOption );
     foreach ( $serializedCustomDataOption as $tableInfoOption )
     {
-        $tableInfo = split( '\;', $tableInfoOption );
+        $tableInfo = explode( ';', $tableInfoOption );
         if ( count( $tableInfo ) != 2 )
         {
             showError( "invalid 'extra-serialized-data' '$tableInfoOption' option" );
         }
 
-        $dataInfo = split( '\.', $tableInfo[0] );
-        $keyInfo = split( '\.', $tableInfo[1] );
+        $dataInfo = explode( '.', $tableInfo[0] );
+        $keyInfo = explode( '.', $tableInfo[1] );
 
         switch ( count( $dataInfo ) )
         {
Index: bin/php/ezflowupgrade.php
===================================================================
--- bin/php/ezflowupgrade.php	(revision 23223)
+++ bin/php/ezflowupgrade.php	(working copy)
@@ -298,7 +298,7 @@
 }
 else
 {
-    $packageList = split( ' ', $packageList );
+    $packageList = explode( ' ', $packageList );
 }
 
 //
Index: bin/php/ezgeneratetranslationcache.php
===================================================================
--- bin/php/ezgeneratetranslationcache.php	(revision 23223)
+++ bin/php/ezgeneratetranslationcache.php	(working copy)
@@ -63,7 +63,7 @@
 //
 // 'ts-list' option
 //
-$translations = isset( $scriptOptions['ts-list'] ) ? split( ' ', $scriptOptions['ts-list'] ) : array();
+$translations = isset( $scriptOptions['ts-list'] ) ? explode( ' ', $scriptOptions['ts-list'] ) : array();
 $translations = eZTSTranslator::fetchList( $translations );
 
 
Index: bin/php/ezwebinupgrade.php
===================================================================
--- bin/php/ezwebinupgrade.php	(revision 23223)
+++ bin/php/ezwebinupgrade.php	(working copy)
@@ -462,7 +462,7 @@
 }
 else
 {
-    $packageList = split( ' ', $packageList );
+    $packageList = explode( ' ', $packageList );
 }
 
 //
Index: cronjobs/linkcheck.php
===================================================================
--- cronjobs/linkcheck.php	(revision 23223)
+++ cronjobs/linkcheck.php	(working copy)
@@ -54,8 +54,8 @@
             if ( eZSys::osType() != 'win32' )
             {
                 $url = trim( preg_replace("/^mailto:(.+)/i", "\\1", $url));
-                list($userName, $host) = split("@", $url);
-                list($host, $junk)= split("\?", $host);
+                list($userName, $host) = explode( '@', $url );
+                list($host, $junk) = explode( '?', $host );
                 $dnsCheck = checkdnsrr( $host,"MX" );
                 if ( !$dnsCheck )
                 {
Index: cronjobs/updateviewcount.php
===================================================================
--- cronjobs/updateviewcount.php	(revision 23223)
+++ cronjobs/updateviewcount.php	(working copy)
@@ -116,14 +116,14 @@
                 {
                     $logPartArray = preg_split( "/[\"]+/", $line );
                     $timeIPPart = $logPartArray[0];
-                    list( $ip, $timePart ) = split( "\[", $timeIPPart );
-                    list( $time, $rest ) = split( " ", $timePart );
+                    list( $ip, $timePart ) = explode( '[', $timeIPPart );
+                    list( $time, $rest ) = explode( ' ', $timePart );
 
                     if ( $time == $startTime )
                         $stopParse = true;
                     $requirePart = $logPartArray[1];
 
-                    list( $requireMethod, $url ) = split( " ", $requirePart );
+                    list( $requireMethod, $url ) = explode( ' ', $requirePart );
                     $url = preg_replace( "/\?.*/", "", $url);
                     foreach ( $prefixes as $prefix )
                     {
@@ -144,7 +144,7 @@
                     }
                     else
                     {
-                        $urlArray = split( "/", $url );
+                        $urlArray = explode( '/', $url );
                         $firstElement = $urlArray[0];
                         if ( in_array( $firstElement, $contentArray ) )
                         {
Index: kernel/class/ezclassfunctions.php
===================================================================
--- kernel/class/ezclassfunctions.php	(revision 23223)
+++ kernel/class/ezclassfunctions.php	(working copy)
@@ -33,7 +33,7 @@
 {
     static function addGroup( $classID, $classVersion, $selectedGroup )
     {
-        list ( $groupID, $groupName ) = split( '/', $selectedGroup );
+        list ( $groupID, $groupName ) = explode( '/', $selectedGroup );
         $ingroup = eZContentClassClassGroup::create( $classID, $classVersion, $groupID, $groupName );
         $ingroup->store();
         return true;
Index: kernel/classes/datatypes/ezuser/ezuser.php
===================================================================
--- kernel/classes/datatypes/ezuser/ezuser.php	(revision 23223)
+++ kernel/classes/datatypes/ezuser/ezuser.php	(working copy)
@@ -2679,7 +2679,7 @@
         }
         else if ( $cacheUserPolicies != 'disabled' )
         {
-            $cachableIDs = split( ',', $cacheUserPolicies );
+            $cachableIDs = explode( ',', $cacheUserPolicies );
             if ( in_array( $id, $cachableIDs ) )
             {
                 // var_dump("BUILD FILENAME FOR $id");
Index: kernel/classes/datatypes/ezxmltext/ezxmlinputparser.php
===================================================================
--- kernel/classes/datatypes/ezxmltext/ezxmlinputparser.php	(revision 23223)
+++ kernel/classes/datatypes/ezxmltext/ezxmlinputparser.php	(working copy)
@@ -603,7 +603,7 @@
                 continue;
             }
 
-            list( $attrName, $attrValue ) = split( '="', $attrStr );
+            list( $attrName, $attrValue ) = explode( '="', $attrStr );
 
             $attrName = strtolower( trim( $attrName ) );
             if ( !$attrName )
Index: kernel/classes/ezurlaliasml.php
===================================================================
--- kernel/classes/ezurlaliasml.php	(revision 23223)
+++ kernel/classes/ezurlaliasml.php	(working copy)
@@ -421,7 +421,7 @@
             $languageMask |= 1;
 
         $path = eZURLAliasML::cleanURL( $path );
-        $elements = split( "/", $path );
+        $elements = explode( '/', $path );
 
         $db = eZDB::instance();
         $parentID = 0;
@@ -1143,7 +1143,7 @@
         if ( $uriString == '' && $glob !== false )
             $elements = array();
         else
-            $elements = split( "/", $uriString );
+            $elements = explode( '/', $uriString );
         $len      = count( $elements );
         $i = 0;
         $selects = array();
@@ -1422,7 +1422,7 @@
         }
 
         $db = eZDB::instance();
-        $elements = split( "/", $internalURIString );
+        $elements = explode( '/', $internalURIString );
         $len      = count( $elements );
         if ( $reverse )
         {
Index: kernel/classes/workflowtypes/event/ezapprove/ezapprovetype.php
===================================================================
--- kernel/classes/workflowtypes/event/ezapprove/ezapprovetype.php	(revision 23223)
+++ kernel/classes/workflowtypes/event/ezapprove/ezapprovetype.php	(working copy)
@@ -711,7 +711,7 @@
                          foreach ( $excludedGroupsID as $groupID )
                          {
                              // $IDArray will contain IDs of "Excluded user groups"
-                             $IDArray = split( ',', $groupID[ 'data_text2' ] );
+                             $IDArray = explode( ',', $groupID[ 'data_text2' ] );
                              // $newIDArray will contain  array without $contentObjectID
                              $newIDArray = array_filter( $IDArray, create_function( '$v', 'return ( $v != ' . $contentObjectID .' );' ) );
                              $newValues = $db->escapeString( implode( ',', $newIDArray ) );
Index: kernel/search/plugins/ezsearchengine/ezsearchengine.php
===================================================================
--- kernel/search/plugins/ezsearchengine/ezsearchengine.php	(revision 23223)
+++ kernel/search/plugins/ezsearchengine/ezsearchengine.php	(working copy)
@@ -118,7 +118,7 @@
                     {
                         $integerValue = 0;
                     }
-                    $wordArray = split( " ", $text );
+                    $wordArray = explode( ' ', $text );
 
                     foreach ( $wordArray as $word )
                     {
@@ -1334,7 +1334,7 @@
         $text = preg_replace("(\s+)", " ", $text );
 
         // Split text on whitespace
-        $wordArray = split( " ", $text );
+        $wordArray = explode( ' ', $text );
 
         $retArray = array();
         foreach ( $wordArray as $word )
Index: kernel/settings/view.php
===================================================================
--- kernel/settings/view.php	(revision 23223)
+++ kernel/settings/view.php	(working copy)
@@ -66,7 +66,7 @@
         $deletedSettingArray = $http->postVariable( 'RemoveSettingsArray' );
         foreach ( $deletedSettingArray as $deletedSetting )
         {
-            list( $block, $setting ) = split( ':', $deletedSetting );
+            list( $block, $setting ) = explode( ':', $deletedSetting );
 
             if ( is_array( $placements[$block][$setting] ) )
             {
Index: kernel/setup/ezsetuptests.php
===================================================================
--- kernel/setup/ezsetuptests.php	(revision 23223)
+++ kernel/setup/ezsetuptests.php	(working copy)
@@ -280,7 +280,7 @@
 
     /*
      // Get the operating systems name
-    $operatingSystem = split( " ", php_uname() );
+    $operatingSystem = explode( ' ', php_uname() );
     $operatingSystem = strtolower( $operatingSystem[0] );
 
     // Find out if there is an os specific version needed
Index: kernel/workflow/ezworkflowfunctions.php
===================================================================
--- kernel/workflow/ezworkflowfunctions.php	(revision 23223)
+++ kernel/workflow/ezworkflowfunctions.php	(working copy)
@@ -33,7 +33,7 @@
 {
     static function addGroup( $workflowID, $workflowVersion, $selectedGroup )
     {
-        list ( $groupID, $groupName ) = split( "/", $selectedGroup );
+        list ( $groupID, $groupName ) = explode( '/', $selectedGroup );
         $ingroup = eZWorkflowGroupLink::create( $workflowID, $workflowVersion, $groupID, $groupName );
         $ingroup->store();
         return true;
Index: lib/ezdb/classes/ezpostgresqldb.php
===================================================================
--- lib/ezdb/classes/ezpostgresqldb.php	(revision 23223)
+++ lib/ezdb/classes/ezpostgresqldb.php	(working copy)
@@ -598,7 +598,7 @@
                 $array = pg_fetch_row( $result, 0 );
                 $versionText = $array[0];
             }
-            list( $dbType, $versionInfo ) = split( " ", $versionText );
+            list( $dbType, $versionInfo ) = explode( ' ', $versionText );
             $versionArray = explode( '.', $versionInfo );
             return array( 'string' => $versionInfo,
                           'values' => $versionArray );
Index: lib/ezdbschema/classes/ezpgsqlschema.php
===================================================================
--- lib/ezdbschema/classes/ezpgsqlschema.php	(revision 23223)
+++ lib/ezdbschema/classes/ezpgsqlschema.php	(working copy)
@@ -265,7 +265,7 @@
             $fields = array();
             $kn = $row['relname'];
 
-            $column_id_array = split( ' ', $row['indkey'] );
+            $column_id_array = explode( ' ', $row['indkey'] );
             if ( $row['indisprimary'] == 't' )
             {
                 // If the name of the key matches our primary key naming standard
Index: lib/ezdiff/classes/ezdifftextengine.php
===================================================================
--- lib/ezdiff/classes/ezdifftextengine.php	(revision 23223)
+++ lib/ezdiff/classes/ezdifftextengine.php	(working copy)
@@ -65,8 +65,8 @@
         $old = preg_replace( $pattern, $replace, $fromData );
         $new = preg_replace( $pattern, $replace, $toData );
 
-        $oldArray = split( "\r\n", $old );
-        $newArray = split( "\r\n", $new );
+        $oldArray = explode( "\r\n", $old );
+        $newArray = explode( "\r\n", $new );
 
         $oldSums = array();
         foreach( $oldArray as $paragraph )
Index: lib/ezdiff/classes/ezdiffxmltextengine.php
===================================================================
--- lib/ezdiff/classes/ezdiffxmltextengine.php	(revision 23223)
+++ lib/ezdiff/classes/ezdiffxmltextengine.php	(working copy)
@@ -92,8 +92,8 @@
             $new = preg_replace( $pattern, $replace, $new );
         }
 
-        $oldArray = split( "\n", $old );
-        $newArray = split( "\n", $new );
+        $oldArray = explode( "\n", $old );
+        $newArray = explode( "\n", $new );
 
         $oldSums = array();
         foreach( $oldArray as $paragraph )
Index: lib/ezi18n/classes/ezcodemapper.php
===================================================================
--- lib/ezi18n/classes/ezcodemapper.php	(revision 23223)
+++ lib/ezi18n/classes/ezcodemapper.php	(working copy)
@@ -1663,7 +1663,7 @@
             $commands = $ini->variable( 'Extensions', 'Commands' );
             if ( isset( $commands[$command['command']] ) )
             {
-                list( $path, $className ) = split( ":", $commands[$command['command']], 2 );
+                list( $path, $className ) = explode( ':', $commands[$command['command']], 2 );
                 if ( file_exists( $path ) )
                 {
                     $charsetNameTxt = var_export( $charsetName, true );
@@ -1807,7 +1807,7 @@
             $commands = $ini->variable( 'Extensions', 'Commands' );
             if ( isset( $commands[$command['command']] ) )
             {
-                list( $path, $className ) = split( ":", $commands[$command['command']], 2 );
+                list( $path, $className ) = explode( ':', $commands[$command['command']], 2 );
                 if ( file_exists( $path ) )
                 {
                     include_once( $path );
Index: lib/ezwebdav/classes/ezwebdavserver.php
===================================================================
--- lib/ezwebdav/classes/ezwebdavserver.php	(revision 23223)
+++ lib/ezwebdav/classes/ezwebdavserver.php	(working copy)
@@ -425,7 +425,7 @@
             // The following lines take care of URL encoding special characters
             // for each element (stuff between slashes) in the path.
             $href = $entry['href'];
-            $pathArray = split( '/', eZWebDAVServer::recode( "$href", $dataCharset, $xmlCharset ) );
+            $pathArray = explode( '/', eZWebDAVServer::recode( "$href", $dataCharset, $xmlCharset ) );
 
             $encodedPath = '/';
 
Index: tests/tests/kernel/private/webdav/wrappers.php
===================================================================
--- tests/tests/kernel/private/webdav/wrappers.php	(revision 23223)
+++ tests/tests/kernel/private/webdav/wrappers.php	(working copy)
@@ -219,7 +219,7 @@
             // The following lines take care of URL encoding special characters
             // for each element (stuff between slashes) in the path.
             $href = $entry['href'];
-            $pathArray = split( '/', eZWebDAVServer::recode( "$href", $dataCharset, $xmlCharset ) );
+            $pathArray = explode( '/', eZWebDAVServer::recode( "$href", $dataCharset, $xmlCharset ) );
 
             $encodedPath = '/';
 