Index: kernel/classes/ezcontentclass.php
===================================================================
--- kernel/classes/ezcontentclass.php	(revision 23534)
+++ kernel/classes/ezcontentclass.php	(working copy)
@@ -66,7 +66,7 @@
 
     static function definition()
     {
-        return array( "fields" => array( "id" => array( 'name' => 'ID',
+        static $definition = array( "fields" => array( "id" => array( 'name' => 'ID',
                                                         'datatype' => 'integer',
                                                         'default' => 0,
                                                         'required' => true ),
@@ -170,6 +170,7 @@
                       "class_name" => "eZContentClass",
                       "sort" => array( "id" => "asc" ),
                       "name" => "ezcontentclass" );
+        return $definition;
     }
 
     function __clone()
Index: kernel/classes/ezcontentclassattribute.php
===================================================================
--- kernel/classes/ezcontentclassattribute.php	(revision 23534)
+++ kernel/classes/ezcontentclassattribute.php	(working copy)
@@ -54,7 +54,7 @@
 
     static function definition()
     {
-        return array( 'fields' => array( 'id' => array( 'name' => 'ID',
+        static $definition = array( 'fields' => array( 'id' => array( 'name' => 'ID',
                                                         'datatype' => 'integer',
                                                         'default' => 0,
                                                         'required' => true ),
@@ -165,6 +165,7 @@
                       'sort' => array( 'placement' => 'asc' ),
                       'class_name' => 'eZContentClassAttribute',
                       'name' => 'ezcontentclass_attribute' );
+        return $definition;
     }
 
     function __clone()
Index: kernel/classes/ezcontentlanguage.php
===================================================================
--- kernel/classes/ezcontentlanguage.php	(revision 23534)
+++ kernel/classes/ezcontentlanguage.php	(working copy)
@@ -47,7 +47,7 @@
      */
     static function definition()
     {
-        return array( 'fields' => array( 'id' => array( 'name' => 'ID',
+        static $definition = array( 'fields' => array( 'id' => array( 'name' => 'ID',
                                                         'datatype' => 'integer',
                                                         'required' => true ),
                                          'name' => array( 'name' => 'Name',
@@ -68,6 +68,7 @@
                       'sort' => array( 'name' => 'asc' ),
                       'class_name' => 'eZContentLanguage',
                       'name' => 'ezcontent_language' );
+        return $definition;
     }
 
     /**
Index: kernel/classes/ezcontentobject.php
===================================================================
--- kernel/classes/ezcontentobject.php	(revision 23534)
+++ kernel/classes/ezcontentobject.php	(working copy)
@@ -97,7 +97,7 @@
 
     static function definition()
     {
-        return array( "fields" => array( "id" => array( 'name' => 'ID',
+        static $definition = array( "fields" => array( "id" => array( 'name' => 'ID',
                                                         'datatype' => 'integer',
                                                         'default' => 0,
                                                         'required' => true ),
@@ -226,6 +226,7 @@
                       "class_name" => "eZContentObject",
                       "sort" => array( "id" => "asc" ),
                       "name" => "ezcontentobject" );
+        return $definition;
     }
 
     /*!
Index: kernel/classes/ezcontentobjectattribute.php
===================================================================
--- kernel/classes/ezcontentobjectattribute.php	(revision 23534)
+++ kernel/classes/ezcontentobjectattribute.php	(working copy)
@@ -55,7 +55,7 @@
 
     static function definition()
     {
-        return array( "fields" => array( "id" => array( 'name' => 'ID',
+        static $definition = array( "fields" => array( "id" => array( 'name' => 'ID',
                                                         'datatype' => 'integer',
                                                         'default' => 0,
                                                         'required' => true ),
@@ -148,6 +148,7 @@
                       "class_name" => "eZContentObjectAttribute",
                       "sort" => array( "id" => "asc" ),
                       "name" => "ezcontentobject_attribute" );
+        return $definition;
     }
 
     static function fetch( $id, $version, $asObject = true, $field_filters = null )
Index: kernel/classes/ezcontentobjecttreenode.php
===================================================================
--- kernel/classes/ezcontentobjecttreenode.php	(revision 23534)
+++ kernel/classes/ezcontentobjecttreenode.php	(working copy)
@@ -87,7 +87,7 @@
 
     static function definition()
     {
-        return array( "fields" => array( "node_id" => array( 'name' => "NodeID",
+        static $definition = array( "fields" => array( "node_id" => array( 'name' => "NodeID",
                                                              'datatype' => 'integer',
                                                              'default' => 0,
                                                              'required' => true ),
@@ -199,6 +199,7 @@
                       "increment_key" => "node_id",
                       "class_name" => "eZContentObjectTreeNode",
                       "name" => "ezcontentobject_tree" );
+        return $definition;
     }
 
     /*!
Index: kernel/classes/ezcontentobjectversion.php
===================================================================
--- kernel/classes/ezcontentobjectversion.php	(revision 23534)
+++ kernel/classes/ezcontentobjectversion.php	(working copy)
@@ -56,7 +56,7 @@
 
     static function definition()
     {
-        return array( "fields" => array( 'id' =>  array( 'name' => 'ID',
+        static $definition = array( "fields" => array( 'id' =>  array( 'name' => 'ID',
                                                          'datatype' => 'integer',
                                                          'default' => 0,
                                                          'required' => true ),
@@ -137,6 +137,7 @@
                       "increment_key" => "id",
                       'sort' => array( 'version' => 'asc' ),
                       'name' => 'ezcontentobject_version' );
+        return $definition;
     }
 
     static function statusList( $limit = false )
Index: kernel/classes/ezsection.php
===================================================================
--- kernel/classes/ezsection.php	(revision 23534)
+++ kernel/classes/ezsection.php	(working copy)
@@ -50,7 +50,7 @@
     */
     static function definition()
     {
-        return array( "fields" => array( "id" => array( 'name' => 'ID',
+        static $definition = array( "fields" => array( "id" => array( 'name' => 'ID',
                                                         'datatype' => 'integer',
                                                         'default' => 0,
                                                         'required' => true ),
@@ -71,6 +71,7 @@
                       "class_name" => "eZSection",
                       "sort" => array( "name" => "asc" ),
                       "name" => "ezsection" );
+        return $definition;
     }
 
     /*!
Index: kernel/classes/datatypes/ezuser/ezuser.php
===================================================================
--- kernel/classes/datatypes/ezuser/ezuser.php	(revision 23534)
+++ kernel/classes/datatypes/ezuser/ezuser.php	(working copy)
@@ -68,7 +68,7 @@
 
     static function definition()
     {
-        return array( 'fields' => array( 'contentobject_id' => array( 'name' => 'ContentObjectID',
+        static $definition = array( 'fields' => array( 'contentobject_id' => array( 'name' => 'ContentObjectID',
                                                                       'datatype' => 'integer',
                                                                       'default' => 0,
                                                                       'required' => true,
@@ -111,6 +111,7 @@
                                                                          'field' => 'id' ) ),
                       'class_name' => 'eZUser',
                       'name' => 'ezuser' );
+        return $definition;
     }
 
     /*!