Index: classes/ezfezpsolrquerybuilder.php
===================================================================
--- classes/ezfezpsolrquerybuilder.php	(revision 3)
+++ classes/ezfezpsolrquerybuilder.php	(revision 2)
@@ -107,7 +107,7 @@
     {
         eZDebug::writeDebug( $params, 'search params' );
         $searchCount = 0;
-        $rawFilters = ( isset( $params['RawFilters'] ) ) ? $params['RawFilters'] : null;
+
         $offset = ( isset( $params['SearchOffset'] ) && $params['SearchOffset'] ) ? $params['SearchOffset'] : 0;
         $limit = ( isset( $params['SearchLimit']  ) && $params['SearchLimit'] ) ? $params['SearchLimit'] : 10;
         $subtrees = isset( $params['SearchSubTreeArray'] ) ? $params['SearchSubTreeArray'] : array();
@@ -193,19 +193,10 @@
             $filterQuery[] = $paramFilterQuery;
         }
 
-        //add raw filters based on ini
-        $iniRawFilters = self::$FindINI->variable( 'SearchFilters', 'RawFilterList' );
-        if ( is_array( $iniRawFilters ) )
-        {
-            $filterQuery = array_merge( $filterQuery, $iniRawFilters );
-        }
-        // Add raw filters based on fetch parameters
-        if ( !is_null( $rawFilters ) )
+        //add raw filters
+        $rawFilters = self::$FindINI->variable( 'SearchFilters', 'RawFilterList' );
+        if ( is_array( $rawFilters ) )
         {
-            if ( !is_array( $rawFilters ) )
-            {
-                $rawFilters = array( $rawFilters );
-            }
             $filterQuery = array_merge( $filterQuery, $rawFilters );
         }
 
Index: classes/ezfmodulefunctioncollection.php
===================================================================
--- classes/ezfmodulefunctioncollection.php	(revision 3)
+++ classes/ezfmodulefunctioncollection.php	(revision 2)
@@ -101,7 +101,7 @@
      *
      * @return array Search result
      */
-    public function search( $query, $rawFilters = null, $offset = 0, $limit = 10, $facets = null,
+    public function search( $query, $offset = 0, $limit = 10, $facets = null,
                             $filters = null, $sortBy = null, $classID = null, $sectionID = null,
                             $subtreeArray = null, $ignoreVisibility = false, $limitation = null,
                             $asObjects = true, $spellCheck = null, $boostFunctions = null, $queryHandler = 'ezpublish' )
@@ -112,7 +112,6 @@
                          'Facet' => $facets,
                          'SortBy' => $sortBy,
                          'Filter' => $filters,
-                         'RawFilters' => $rawFilters,
                          'SearchContentClassID' => $classID,
                          'SearchSectionID' => $sectionID,
                          'SearchSubTreeArray' => $subtreeArray,
Index: modules/ezfind/function_definition.php
===================================================================
--- modules/ezfind/function_definition.php	(revision 3)
+++ modules/ezfind/function_definition.php	(revision 2)
@@ -40,10 +40,6 @@
                                                                'type' => 'string',
                                                                'required' => true,
                                                                'default' => '' ),
-                                                        array( 'name' => 'raw_filters',
-                                                               'type' => 'array',
-                                                               'required' => false,
-                                                               'default' => null ),
                                                         array( 'name' => 'offset',
                                                                'type' => 'integer',
                                                                'required' => false,
@@ -99,8 +95,7 @@
                                                         array( 'name' => 'query_handler',
                                                                'type' => 'string',
                                                                'required' => false,
-                                                               'default' => null )
-                                                         ) );
+                                                               'default' => null ) ) );
 
 $FunctionList['facetParameters'] = array( 'name' => 'facetParameters',
                                           'operation_types' => 'read',